#ifdef __cplusplus
extern "C" {
#endif


//-------- クロックの設定 --------//
extern void RCC_Config();

//-------- ベクタテーブル --------//
extern void InitVectorTable();

//-------- シリアル通信関係 --------//
extern void SIO_Config();
extern volatile char inkey();
#define ClearRxb() while(inkey()!=0);
extern char inbyte();
extern void outbyte(char c);

//-------- モータ制御 --------//
extern void Motor_Config_TIM1();
extern void Motor_Config_TIM8();
#define MAXDUTY 900
extern void SetDuty_TIM1_14(int duty); // [‰]
extern void SetDuty_TIM8_12(int duty); // [‰]
extern void SetDuty_TIM8_34(int duty); // [‰]

//-------- エンコーダ関係 --------//
extern void Encoder_Config_TIM3();
extern void Encoder_Config_TIM4();
extern void Encoder_Config_TIM5();
extern short encCounter_TIM3();
extern short encCounter_TIM4();
extern short encCounter_TIM5();
extern void SetEncCounter_TIM3(short counter);
extern void SetEncCounter_TIM4(short counter);
extern void SetEncCounter_TIM5(short counter);

//-------- 入出力ポート --------//
extern void IO_Config();
extern volatile int enter();

//-------- AD変換 --------//
#define nADC 16
extern short ADC_table[nADC*2];
#define ADC_data(x, y) ADC_table[(y)*2+(x)-3] // ADCxのy番目のデータ
extern void ADC_Config();

//-------- 周期タイマ --------//
#define T_INTERVAL 1000 // 制御周期 [us]
static const float dt = T_INTERVAL*1.E-6;
extern void IntervalTimer_Config();
extern volatile float absTime; // [s]
extern int dutyTimer; // [‰]
extern int dutyTimer_max; // [‰]
extern void PreIntRoutine();
extern void PostIntRoutine();
extern void StopIntervalTimer();
extern void RestartIntervalTimer();
extern void StopIntervalInterrupt();
extern void RestartIntervalInterrupt();
extern void Wait(float time); // [s]

//-------- ROMへの書き込み --------//
#define FLASH_PAGE_SIZE 0x800 // 2kbyte
void EraseRom(long addr, long size);
void WriteToRomWord(long addr, long data);
#define MAZE_ADDR 0x8070000
#define MAZE_ROM_SIZE 0x2000 // 8kBytes
#define PARM_ADDR 0x807d000 // ここから2kbytes
#define PARM_ROM_SIZE 0x800


#ifdef __cplusplus
}
#endif

