#include <stdio.h>
#include <stm32f10x.h>
#include "config.h"

extern "C" { extern void startup(); }

void CheckModules();

int main(void)
{
	// スタートアップルーチン
	startup();
	
	// クロックの設定
	RCC_Config();
	// 割り込みテーブル位置のoffset
	InitVectorTable();
	// シリアル通信関係の設定
	SIO_Config();
	
	// rlogの初期化
//	rlog.init();
	// IOポート
//	IO_Config();
	// エンコーダ用タイマ
//	Encoder_Config_TIM3();
//	Encoder_Config_TIM4();
//	Encoder_Config_TIM5();
	// AD変換関係
//	ADC_Config();
	// モータ制御関係
//	Motor_Config_TIM1();
//	Motor_Config_TIM8();
	// 周期タイマ設定
	IntervalTimer_Config();
	
	
	//CheckModules();
	
	while(1){
		printf("Hello world!\r\n");
	}
	
	return 0;
}


void CheckModules()
{
	char c;
	float time;
	int duty_left = 0;
	int duty_right = 0;

	ClearRxb(); // 受信バッファをクリア
	while(1){
		// 各種変数値の表示
		const int line1 = __LINE__;
		printf("TIME: %8.3f [s]\r\n",absTime);
		printf("enter: %s\r\n",(enter()==1) ? "on" : "off");
		printf("duty: %6d  %6d\r\n",duty_left, duty_right);
		printf("AD1:  %4d  %4d\r\n",ADC_data(1,1), ADC_data(2,1));
		printf("AD2:  %4d  %4d\r\n",ADC_data(1,2), ADC_data(2,2));
		printf("AD3:  %4d  %4d\r\n",ADC_data(1,3), ADC_data(2,3));
		printf("AD4:  %4d  %4d\r\n",ADC_data(1,4), ADC_data(2,4));
		printf("AD5:  %4d  %4d\r\n",ADC_data(1,5), ADC_data(2,5));
		printf("AD6:  %4d  %4d\r\n",ADC_data(1,6), ADC_data(2,6));
		printf("AD7:  %4d  %4d\r\n",ADC_data(1,7), ADC_data(2,7));
		printf("AD8:  %4d  %4d\r\n",ADC_data(1,8), ADC_data(2,8));
		printf("AD9:  %4d  %4d\r\n",ADC_data(1,9), ADC_data(2,9));
		printf("AD10: %4d  %4d\r\n",ADC_data(1,10), ADC_data(2,10));
		printf("AD11: %4d  %4d\r\n",ADC_data(1,11), ADC_data(2,11));
		printf("AD12: %4d  %4d\r\n",ADC_data(1,12), ADC_data(2,12));
		printf("AD13: %4d  %4d\r\n",ADC_data(1,13), ADC_data(2,13));
		printf("AD14: %4d  %4d\r\n",ADC_data(1,14), ADC_data(2,14));
		printf("AD15: %4d  %4d\r\n",ADC_data(1,15), ADC_data(2,15));
		printf("AD16: %4d  %4d\r\n",ADC_data(1,16), ADC_data(2,16));
		const int line = __LINE__ - line1 - 1;
		
		time = ((int)(absTime/0.5)+1) * 0.5;
		// キー入力の処理
		while(absTime < time){
			c = inkey();
			switch(c){
			case '1': duty_left = (duty_left+100 >  MAXDUTY ?  MAXDUTY : duty_left+100); break;
			case 'q': duty_left = (duty_left-100 < -MAXDUTY ? -MAXDUTY : duty_left-100); break;
			case '2': duty_right = (duty_right+100 >  MAXDUTY ?  MAXDUTY : duty_right+100); break;
			case 'w': duty_right = (duty_right-100 < -MAXDUTY ? -MAXDUTY : duty_right-100); break;
			case 'r': // reset
				duty_left = duty_right = 0;
				break;
			case 'z': goto END; // exit
			}
			// 各定数の設定
			SetDuty_TIM8_12(duty_left);
			SetDuty_TIM8_34(duty_right);
		}

		printf("%c[%dA",0x1b,line);
		printf("%c[0J",0x1b);
		fflush(stdout);
	}
	END:;
	ClearRxb();
}

