/* メモリ定義
  RAM     mainプログラム用ram領域
  RAMst   staticプログラム用ram領域 + ヒープ領域 + スタック領域
  FLASH   mainプログラム用rom領域
  FLASHst staticプログラム用rom領域
*/
MEMORY
{
  RAM (xrw)    : ORIGIN = 0x20000000,            LENGTH = 64k - 6k
  RAMst (xrw)  : ORIGIN = 0x20000000 + 64k - 6k, LENGTH =       6k
  FLASH (rx)   : ORIGIN = 0x08000000,             LENGTH = 384k - 1k
  FLASHst (rx) : ORIGIN = 0x08000000 + 384k - 1k, LENGTH =        1k
}

_RAM_SIZE = 64k;
_ROM_SIZE = 512k;
_USER_ROM_SIZE = 128k;

/* ユーザプログラムからFLASHを使うための領域始点 */
_user_rom = 0x08000000 + _ROM_SIZE - _USER_ROM_SIZE;

/* ヒープとスタック用に最低限確保しておく容量 */
/* この容量を下回るとリンクエラーとなる */
_Minimum_Stack_Size = 5k;

/* スタック終端位置 = RAM終端位置*/
/* スタートアップルーチン内でスタックポインタにこの値がセットさせる */
_estack = 0x20000000 + _RAM_SIZE;
